; http://www.masm32.com/board/index.php?topic=5210.msg38936#msg38936
; kudos to kunt0r!

include \masm32\include\masm32rt.inc

GdiplusStartup_proto	typedef	proto :dword, :dword, :dword
GdiplusStartup_proc	typedef	ptr GdiplusStartup_proto
GdiplusShutdown_proto	typedef	proto :dword
GdiplusShutdown_proc	typedef	ptr GdiplusShutdown_proto
GdipLoadImageFromFile_proto	typedef	proto :dword, :dword
GdipLoadImageFromFile_proc	typedef	ptr GdipLoadImageFromFile_proto
GdipSaveImageToFile_proto	typedef	proto :dword, :dword, :dword, :dword
GdipSaveImageToFile_proc	typedef	ptr GdipSaveImageToFile_proto
GdipGetImageEncodersSize_proto	typedef	proto :dword, :dword
GdipGetImageEncodersSize_proc	typedef	ptr GdipGetImageEncodersSize_proto
GdipGetImageEncoders_proto	typedef	proto :dword, :dword, :dword
GdipGetImageEncoders_proc	typedef	ptr GdipGetImageEncoders_proto
GdipDisposeImage_proto	typedef	proto :dword
GdipDisposeImage_proc	typedef	ptr GdipDisposeImage_proto

initpng	proto
bmptopng	proto:DWORD,:DWORD	;usage: invoke bmptopng, addr bmpa, addr pnga 
uninitpng	proto

GdiplusStartupInput	struct
GdiplusVersion	dd ?
DebugEventCallback	dd ?
SuppressBackgroundThread	dd ?
SuppressExternalCodecs	dd ?
GdiplusStartupInput ends

GdiplusStartupOutput struct
NotificationHook	dd ?
NotificationUnhook	dd ?
GdiplusStartupOutput ends

ImageCodecInfo struct
Clsid	dd ?, ?, ?, ?
FormatID	dd ?, ?, ?, ?
CodecName	dd ?
DllName	dd ?
FormatDescription	dd ?
FilenameExtension	dd ?
MimeType	dd ?
Flags	dd ?
Version	dd ?
SigCount	dd ?
SigSize	dd ?
SigPattern	dd ?
SigMask	dd ?
ImageCodecInfo ends

.data?
gditoken	dd ?
GdiplusStartup	GdiplusStartup_proc ?
GdiplusShutdown	GdiplusShutdown_proc ?
GdipLoadImageFromFile	GdipLoadImageFromFile_proc ?
GdipSaveImageToFile	GdipSaveImageToFile_proc ?
GdipGetImageEncodersSize	GdipGetImageEncodersSize_proc ?
GdipGetImageEncoders	GdipGetImageEncoders_proc ?
GdipDisposeImage	GdipDisposeImage_proc ?

.data

AppName	db	"BMP to png converter",0
AskUser	db	"Test the conversion?",0

.code
gdiplus_dll db "gdiplus.dll", 0

; Image type for saving. Use ie image/bmp, image/gif, image/png, image/png. Must be unicode.
mime_type dw 'i', 'm', 'a', 'g', 'e', '/', 'p', 'n', 'g', 0

; ex-sig.bmp, change to suit your needs. Must be unicode.

bmpa	dw	'p','i','c','\','p','a','.','b','m','p',0
bmpb	dw	'p','i','c','\','p','b','.','b','m','p',0
bmpc	dw	'p','i','c','\','p','c','.','b','m','p',0
bmpd	dw	'p','i','c','\','p','d','.','b','m','p',0
bmpe	dw	'p','i','c','\','p','e','.','b','m','p',0
bmpf	dw	'p','i','c','\','p','f','.','b','m','p',0
bmpg	dw	'p','i','c','\','p','g','.','b','m','p',0
bmph	dw	'p','i','c','\','p','h','.','b','m','p',0
bmpi	dw	'p','i','c','\','p','i','.','b','m','p',0
bmpj	dw	'p','i','c','\','p','j','.','b','m','p',0
bmpk	dw	'p','i','c','\','p','k','.','b','m','p',0
bmpl	dw	'p','i','c','\','p','l','.','b','m','p',0
bmpm	dw	'p','i','c','\','p','m','.','b','m','p',0
bmpn	dw	'p','i','c','\','p','n','.','b','m','p',0
bmpo	dw	'p','i','c','\','p','o','.','b','m','p',0

pnga	dw	'p','i','c','\','p','a','.','p','n','g',0
pngb	dw	'p','i','c','\','p','b','.','p','n','g',0
pngc	dw	'p','i','c','\','p','c','.','p','n','g',0
pngd	dw	'p','i','c','\','p','d','.','p','n','g',0
pnge	dw	'p','i','c','\','p','e','.','p','n','g',0
pngf	dw	'p','i','c','\','p','f','.','p','n','g',0
pngg	dw	'p','i','c','\','p','g','.','p','n','g',0
pngh	dw	'p','i','c','\','p','h','.','p','n','g',0
pngi	dw	'p','i','c','\','p','i','.','p','n','g',0
pngj	dw	'p','i','c','\','p','j','.','p','n','g',0
pngk	dw	'p','i','c','\','p','k','.','p','n','g',0
pngl	dw	'p','i','c','\','p','l','.','p','n','g',0
pngm	dw	'p','i','c','\','p','m','.','p','n','g',0
pngn	dw	'p','i','c','\','p','n','.','p','n','g',0
pngo	dw	'p','i','c','\','p','o','.','p','n','g',0

LGdiplusStartup db "GdiplusStartup", 0
LGdiplusShutdown db "GdiplusShutdown", 0
LGdipLoadImageFromFile db "GdipLoadImageFromFile", 0
LGdipSaveImageToFile db "GdipSaveImageToFile", 0
LGdipGetImageEncodersSize db "GdipGetImageEncodersSize", 0
LGdipGetImageEncoders db "GdipGetImageEncoders", 0
LGdipDisposeImage db "GdipDisposeImage", 0

start:
	.if rv(MessageBox,NULL,addr AskUser,addr AppName,MB_YESNO or MB_DEFBUTTON2)==IDYES
	  call initpng
	  invoke bmptopng, addr bmpa, addr pnga
	  invoke bmptopng, addr bmpb, addr pngb
	  invoke bmptopng, addr bmpc, addr pngc
	  invoke bmptopng, addr bmpd, addr pngd
	  invoke bmptopng, addr bmpe, addr pnge
	  invoke bmptopng, addr bmpf, addr pngf
	  invoke bmptopng, addr bmpg, addr pngg
	  invoke bmptopng, addr bmph, addr pngh
	  invoke bmptopng, addr bmpi, addr pngi
	  invoke bmptopng, addr bmpj, addr pngj
	  invoke bmptopng, addr bmpk, addr pngk
	  invoke bmptopng, addr bmpl, addr pngl
	  invoke bmptopng, addr bmpm, addr pngm
	  invoke bmptopng, addr bmpn, addr pngn
	  invoke bmptopng, addr bmpo, addr pngo
	  call uninitpng
	.endif
	invoke ExitProcess,eax

initpng proc

local gdiplus:dword
local gdisi:GdiplusStartupInput
local gdiso:GdiplusStartupOutput

invoke LoadLibrary, addr gdiplus_dll
mov gdiplus, eax
invoke GetProcAddress, gdiplus, addr LGdiplusStartup
mov GdiplusStartup, eax
invoke GetProcAddress, gdiplus, addr LGdiplusShutdown
mov GdiplusShutdown, eax
invoke GetProcAddress, gdiplus, addr LGdipLoadImageFromFile
mov GdipLoadImageFromFile, eax
invoke GetProcAddress, gdiplus, addr LGdipSaveImageToFile
mov GdipSaveImageToFile, eax
invoke GetProcAddress, gdiplus, addr LGdipGetImageEncodersSize
mov GdipGetImageEncodersSize, eax
invoke GetProcAddress, gdiplus, addr LGdipGetImageEncoders
mov GdipGetImageEncoders, eax
invoke GetProcAddress, gdiplus, addr LGdipDisposeImage
mov GdipDisposeImage, eax
mov gdisi.GdiplusVersion, 1
and gdisi.DebugEventCallback, 0
and gdisi.SuppressBackgroundThread, 0
and gdisi.SuppressExternalCodecs, 0
invoke GdiplusStartup, addr gditoken, addr gdisi, addr gdiso
ret

initpng endp


bmptopng proc SrcFile:DWORD,DestFile:DWORD

local pngimage:dword
local encnum:dword
local encsize:dword
local encinfo:dword

push ebx

; Load the image from file
invoke GdipLoadImageFromFile, SrcFile, addr pngimage ; addr bmpopen, addr pngimage

; Get the available encode settings

invoke GdipGetImageEncodersSize, addr encnum, addr encsize ; num = encoders availble on the computer, size = total amount of memory needed to store them
invoke VirtualAlloc, 0, encsize, MEM_COMMIT, PAGE_READWRITE
mov encinfo, eax
invoke GdipGetImageEncoders, encnum, encsize, encinfo ; Fills the memory block with all the encoding info

    ; Loop through all the encoders untill we find the one we want (in this case image/jpeg)
mov ebx, encinfo
@@: mov eax, [ebx.ImageCodecInfo.MimeType]
add ebx, sizeof ImageCodecInfo
invoke lstrcmpW, eax, addr mime_type
test eax, eax
jz @F
    dec encnum
    jnz @B
@@: sub ebx, sizeof ImageCodecInfo

; Save the image to a new file, ebx is a pointer to the array storing the CLSID for image/jpeg
invoke GdipSaveImageToFile, pngimage, DestFile, ebx, 0

; Clean up
invoke VirtualFree, encinfo, 0, MEM_RELEASE
invoke GdipDisposeImage, pngimage

pop ebx
ret

bmptopng endp

uninitpng proc

invoke GdiplusShutdown, gditoken
ret

uninitpng endp

end start
